/* Mex interface to David MacKay's macopt gradient-only optimizer.
 * Calling documentation in macopt.m
 * 
 * More information about the macopt optimiser itself is here:
 * 	http://www.inference.phy.cam.ac.uk/mackay/c/macopt.html
 * 	mackay@mrao.cam.ac.uk
 * Note that the optimizer is GPL software, please look at that code for
 * licenses and copyright notices.
 * 
 * This mex interface by Iain Murray, http://www.gatsby.ucl.ac.uk/~iam23/
 * June 2004.
 * 
 * If you find macopt useful, please feel free to make a donation to support
 * David MacKay's research group.
 * 
 * *** THIS CODE COMES WITH NO WARRANTY OF ANY KIND. ***
 */

#ifndef __macopt_h__
#define __macopt_h__

#include "mex.h"

void gradient(double *x, double *g, void *arg);

/* Structure to contain arguments for mexCallMatlab
 * This can be passed around by macopt to avoid using global variables */
typedef struct {
	unsigned int dim;      /* Number of dimensions */
	mxArray **plhs;        /* Matlab array for gradients */
	int nrhs;              /* Number of args to give to grad function */
	mxArray **grad_args;   /* Points to those arguments */
	char *fn;              /* Gradient function --- as string */
	int fn_len;            /* Length of that string */
} mexCM_args;

#endif /* #ifndef __macopt_h__ */
